var App = function() {
  this.timerId_;
};

App.prototype.init = function() {
  $('#start').click($.proxy(this.handleClickStart, this));
  $('#stop').click($.proxy(this.handleClickStop, this));
};

App.prototype.handleClickStart = function() {
  if (this.timerId_) {
    return;
  }
  this.timerId_ = setInterval($.proxy(this.process, this), 1000);
};

App.prototype.handleClickStop = function() {
  clearInterval(this.timerId_);
};

App.prototype.process = function() {
  this.clearNodes();
  this.createNodes();
};

App.prototype.clearNodes = function() {
  var container = $('#container');
  // emptyメソッドを使ってノードの削除とイベントハンドラの解放を行う
  container.empty();
};

App.prototype.createNodes = function() {
  var container = $('#container');
  var el;
  for (var i = 0; i < 1000; i++) {
    el = $('<div>').text(Math.random());
    this.registerEvents(el);
    container.append(el);
  }
};

App.prototype.registerEvents = function(el) {
  var func = function(e) { console.log(e.type) };
  var events = ['click', 'mouseup', 'mousedown', 'mousemove',
    'mouseover', 'focus', 'blur', 'touchstart', 'touchend'];
  for (var i = 0, len = events.length; i < len; i++) {
    el.on(events[i], func);
  }
};

var app = new App();
app.init();
